﻿Imports System.IO
Imports PdfSharp
Imports PdfSharp.Drawing
Imports PdfSharp.Pdf
Imports PdfSharp.Pdf.IO

Public Class Form1
    Private document As Pdf.PdfDocument             'define main PDF document object for conversion
    Private outline As Pdf.PdfOutline               'define PDF bookmark object
    Private PDFfont As Drawing.XFont                    'following objects and variables used in conversion to PDF
    Dim gfx As Drawing.XGraphics                        'used by PDFSharp to create PDF pages



    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        CreateFile(True)
    End Sub

    Private Sub CreateFile(ByVal blnMultipleLnBkMark As Boolean)

        document = New PdfDocument
        PDFfont = New XFont("Arial", 24, XFontStyle.Bold)
        Dim outline As PdfOutline
        Dim page As PdfPage = document.AddPage()
        Dim textbox As New XRect(page.Width.Value / 2 - 250, page.Height.Value / 2, 500, 50)
        Dim gfx As XGraphics = XGraphics.FromPdfPage(page)
        Dim TF As Layout.XTextFormatter = New Layout.XTextFormatter(gfx)
        Dim drawpen As New XPen(Drawing.XColors.Black, 2)
        TF.Alignment = PdfSharp.Drawing.Layout.XParagraphAlignment.Center
        TF.DrawString("testing bookmark creation", PDFfont, XBrushes.DarkBlue, textbox, XStringFormats.TopLeft)
        '****** if you add a carriage return to bookmark text a bookmark will not be created using PDFSharp v1.5
        If blnMultipleLnBkMark Then
            outline = document.Outlines.Add("test bookmark" & vbCrLf & "2nd line", page, True, PdfOutlineStyle.Bold, XColors.DarkBlue)
        Else
            outline = document.Outlines.Add("test bookmark", page, True, PdfOutlineStyle.Bold, XColors.DarkBlue)
        End If

        Try
            document.Save(Application.StartupPath & "\testbookmark.pdf")     'attempt to save PDF file
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Exit Sub
        End Try
        document.Dispose()
        Try
            Process.Start(Application.StartupPath & "\testbookmark.pdf") 'attempt to open the PDF file with default viewer
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        CreateFile(False)
    End Sub
End Class
